## ros-noetic-rm-gimbal-controllers 0.1.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(rm_gimbal_controllers)

## Use C++14
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

## By adding -Wall and -Werror, the compiler does not ignore warnings anymore,
## enforcing cleaner code.
add_definitions(-Wall -Werror)

## Find catkin macros and libraries

find_package(catkin REQUIRED
        COMPONENTS
        roscpp

        rm_common

        effort_controllers
        tf2_eigen
        tf2_geometry_msgs
        visualization_msgs
        dynamic_reconfigure
        angles
        )

generate_dynamic_reconfigure_options(
        cfg/BulletSolver.cfg
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if your package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
        INCLUDE_DIRS
        include
        LIBRARIES
        CATKIN_DEPENDS
        roscpp

        rm_common

        effort_controllers
        tf2_eigen
        tf2_geometry_msgs
        visualization_msgs
        dynamic_reconfigure
        LIBRARIES ${PROJECT_NAME}
)

###########
## Build ##
###########

## Specify additional locations of header files
include_directories(
        include
        ${catkin_INCLUDE_DIRS}
)

## Declare a cpp library
add_library(${PROJECT_NAME} src/gimbal_base.cpp src/bullet_solver.cpp)

## Specify libraries to link executable targets against
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES})

add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_gencfg)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(
        TARGETS ${PROJECT_NAME}
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Mark cpp header files for installation
install(
        DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
        FILES_MATCHING PATTERN "*.h"
)

# Mark other files for installation
install(
        DIRECTORY test
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(
        FILES rm_gimbal_controllers_plugins.xml
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#############
## Testing ##
#############

#if (${CATKIN_ENABLE_TESTING})
#  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
#  ## Add gtest based cpp test target and link libraries
#  catkin_add_gtest(${PROJECT_NAME}-test
#      test/test_ros_package_template.cpp
#      test/AlgorithmTest.cpp)
#  target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME}_core)
#endif ()

=== debian/changelog ===
ros-noetic-rm-gimbal-controllers (0.1.7-1buster) buster; urgency=high

  * Optimize TRACK mode of rm_gimbal_controller.
  * Change frame "map" to "odom".
  * Merge remote-tracking branch 'origin/master'
  * Contributors: qiayuan, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Sat, 10 Sep 2022 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.6-1buster) buster; urgency=high

  * Merge branch 'gimbal/chassis_vel'
  * Merge pull request #77 <https://github.com/rm-controls/rm_controllers/issues/77> from ye-luo-xi-tui/gimbal/chassis_vel
    Fix a stupid bug
  * Fix a stupid bug.
  * Add chassis_vel as a feedforward to the yaw joint
  * Merge remote-tracking branch 'origin/master'
  * Add chassis_vel to yaw's PID
  * Contributors: QiayuanLiao, qiayuan, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Thu, 16 Jun 2022 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.5-1buster) buster; urgency=high

  * Merge pull request #71 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/71> from ye-luo-xi-tui/gimbal/joint_velocity
    Set joint desired velocity according to the target velocity
  * Fix a bug in setting joint desired velocity.
  * Set joint desired velocity according to the target velocity.
  * Merge pull request #69 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/69> from ChenZheng29/master
    Correct track topic message type:TrackData
  * Merge remote-tracking branch 'origin/master'
  * Merge pull request #66 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/66> from ye-luo-xi-tui/master
    Use motors' data in pid controller when imu_name isn't set
  * Use motors' data in pid controller when imu_name isn't set.
  * Correct the message type of gimbal subscription '/track' topic from 'rm_msgs::TrackCmd' to 'rm_msgs::TrackData'
  * Modify the track topic name and message, and unify the track interface
  * Merge remote-tracking branch 'origin/master'
  * 0.1.4
  * Move all computation in gimbal_controller i.r.t. "odom" instead of "map"
  * Merge pull request #52 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/52> from ye-luo-xi-tui/gimbal_track
    Update gimbal_controller
  * Modifier TrackCmd.msg format.
  * Improve logic of function Controller::setDes().
  * Fix a frame error in track mode.
  * Merge branch 'master' into gimbal_track
  * Merge pull request #45 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/45> from mlione/master
    Delete some config files in rm_controllers.
  * Delete some config files in rm_controller.
  * Merge pull request #46 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/46> from ye-luo-xi-tui/master
    Deprecated imu_filter_controller
  * Merge branch 'master' into gimbal_track
  * Rename a msg.
  * Modifier track subscribe topic
  * Contributors: QiayuanLiao, YuuinIH, chenzheng, mlione, qiayuan, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Fri, 10 Jun 2022 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.3-1buster) buster; urgency=high

  * Merge pull request #42 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/42> from ye-luo-xi-tui/fix_gimbal
    Fix bug in gimbal_controller
  * Merge pull request #37 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/37> from ye-luo-xi-tui/forward_feed
    Add feedforward in gimbal control
  * Merge branch 'master' into forward_feed
  * Simplify the codes. Set vel_target under rate mode.
  * Fix bug which relative to limit in gimbal_controller.
  * Merge pull request #40 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/40> from ye-luo-xi-tui/maintain
    Delete configuration of robot_state_controller in each of controllers' config file
  * Merge branch 'master' into 'standard3'.
  * Merge branch 'master' into maintain
    # Conflicts:
    #     rm_chassis_controllers/config/standard3.yaml
    #     rm_chassis_controllers/config/standard4.yaml
  * Delete configuration of robot_state_controller in each of controllers' config file
  * Merge branch 'master' into standard3
  * Delete eigen, tf2_eigen instead.
  * chore: add missing deps
  * Merge remote-tracking branch 'origin/master'
  * Change frame id of gimbal while transforming angular_vel form imu to pitch/yaw for engineer or sentry.
  * Add feedforward in gimbal control.
  * Contributors: QiayuanLiao, StarHeart, qiayuan, ye-luo-xi-tui, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Mon, 28 Mar 2022 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.2-1buster) buster; urgency=high

  * Merge pull request #30 <https://github.com/rm-controls/rm_controllers/issues/30> from ljq-lv/rm_gimbal_controllers
    Modify namespace on rm_gimbal_controllers
  * Modify namespace from bullet_solver to rm_gimbal_controllers
  * Merge branch 'master' into omni_wheel_controller
  * Merge remote-tracking branch 'origin/master'
  * Merge branch 'rm-controls:master' into master
  * Merge branch 'rm-controls:master' into master
  * Merge pull request #17 <https://github.com/rm-controls/rm_controllers/issues/17> from ChenZheng29/master
    Fix the abnormal gimbal caused by the different representation of angle between TF and URDF
  * Merge branch 'master' of https://github.com/YuuinIH/rm_controllers
  * Add the judgment of the pitch of the gimbal
  * Fix gimbal position limit
  * Merge branch 'gimbal/opti_or_simplify' into chassis/balance_imu_interface
  * Update the config of rm_gimbal_controllers, load only one controller on launch instead of spawn controllers
  * Merge branch 'gimbal/opti_or_simplify' into imu_filter_controllers
  * Test imu2can with gimbal, fix a stupid bug
  * Rename standard to gimbal_base
  * Correct format.
  * Merge branch 'master' into chassis/fix_filter
  * Merge remote-tracking branch 'origin/master'
  * Update static_transform_publisher from tf to tf2
  * Remove updateTf() of rm_gimbal_controllers
  * Fix tf time of rm_gimbal_controllers
  * Use gyro data as gimbal joint velocity.
  * Sort code, add imu_sensor_interface
  * Simplify rm_gimbal_controllers and tested on gazebo


=== debian/control ===
Source: ros-noetic-rm-gimbal-controllers
Section: misc
Priority: optional
Maintainer: Qiayuan Liao <liaoqiayuan@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-angles, ros-noetic-catkin, ros-noetic-dynamic-reconfigure, ros-noetic-effort-controllers, ros-noetic-rm-common, ros-noetic-roscpp, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-rm-gimbal-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-angles, ros-noetic-dynamic-reconfigure, ros-noetic-effort-controllers, ros-noetic-rm-common, ros-noetic-roscpp, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-visualization-msgs
Description: RoboMaster standard robot Gimbal controller

## ros-noetic-rm-gimbal-controllers 0.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,7 @@
 
         rm_common
 
+        controller_interface
         effort_controllers
         tf2_eigen
         tf2_geometry_msgs

=== debian/changelog ===
ros-noetic-rm-gimbal-controllers (0.1.10-1focal) focal; urgency=high

  * Merge branch 'rm-controls:master' into master
  * Merge pull request #114 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/114> from ye-luo-xi-tui/resistance_compensation
    Add resistance compensation on yaw
  * Add resistance compensation on yaw.
  * Merge pull request #113 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/113> from ye-luo-xi-tui/master
    Use Vector3WithFilter in rm_common instead
  * Use Vector3WithFilter in rm_common instead.
  * Merge pull request #106 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/106> from ye-luo-xi-tui/master
    0.1.9
  * Contributors: ye-luo-xi-tui, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Sat, 25 Mar 2023 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.9-1focal) focal; urgency=high

  * Merge pull request #104 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/104> from ye-luo-xi-tui/balance_standard
    Fix bug.
  * Fix bug.
  * Merge pull request #102 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/102> from ljq-lv/fix_warning
    Fixed the bug of gimbal warning
  * Add the else to judge mode TRACK
  * Fixed the bug of gimbal warning
  * Merge branch 'master' into balance_standard
  * Merge pull request #97 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/97> from ye-luo-xi-tui/master
    0.1.8
  * Contributors: ljq-lv, ye-luo-xi-tui, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Tue, 21 Feb 2023 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.8-1focal) focal; urgency=high

  * Merge pull request #92 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/92> from ye-luo-xi-tui/target_velocity_correction
    Estimate chassis vel with moving average and subtract chassis_vel from target_vel
  * Fix trylock bug.
  * Subtract chassis_vel from target_vel.
  * Estimate chassis vel with moving average.
  * Merge pull request #86 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/86> from NaHCO3bc/Readme
    Fix the dependence part bug.
  * Modify the test file folder.
  * Fix the dependence part bug.
  * Merge pull request #85 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/85> from ye-luo-xi-tui/master
    0.1.7
  * Contributors: NaHCO3bc, ye-luo-xi-tui, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Thu, 24 Nov 2022 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.7-1focal) focal; urgency=high

  * Optimize TRACK mode of rm_gimbal_controller.
  * Change frame "map" to "odom".
  * Merge remote-tracking branch 'origin/master'
  * Contributors: qiayuan, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Sat, 10 Sep 2022 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.6-1focal) focal; urgency=high

  * Merge branch 'gimbal/chassis_vel'
  * Merge pull request #77 <https://github.com/rm-controls/rm_controllers/issues/77> from ye-luo-xi-tui/gimbal/chassis_vel
    Fix a stupid bug
  * Fix a stupid bug.
  * Add chassis_vel as a feedforward to the yaw joint
  * Merge remote-tracking branch 'origin/master'
  * Add chassis_vel to yaw's PID
  * Contributors: QiayuanLiao, qiayuan, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Thu, 16 Jun 2022 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.5-1focal) focal; urgency=high

  * Merge pull request #71 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/71> from ye-luo-xi-tui/gimbal/joint_velocity
    Set joint desired velocity according to the target velocity
  * Fix a bug in setting joint desired velocity.
  * Set joint desired velocity according to the target velocity.
  * Merge pull request #69 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/69> from ChenZheng29/master
    Correct track topic message type:TrackData
  * Merge remote-tracking branch 'origin/master'
  * Merge pull request #66 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/66> from ye-luo-xi-tui/master
    Use motors' data in pid controller when imu_name isn't set
  * Use motors' data in pid controller when imu_name isn't set.
  * Correct the message type of gimbal subscription '/track' topic from 'rm_msgs::TrackCmd' to 'rm_msgs::TrackData'
  * Modify the track topic name and message, and unify the track interface
  * Merge remote-tracking branch 'origin/master'
  * 0.1.4
  * Move all computation in gimbal_controller i.r.t. "odom" instead of "map"
  * Merge pull request #52 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/52> from ye-luo-xi-tui/gimbal_track
    Update gimbal_controller
  * Modifier TrackCmd.msg format.
  * Improve logic of function Controller::setDes().
  * Fix a frame error in track mode.
  * Merge branch 'master' into gimbal_track
  * Merge pull request #45 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/45> from mlione/master
    Delete some config files in rm_controllers.
  * Delete some config files in rm_controller.
  * Merge pull request #46 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/46> from ye-luo-xi-tui/master
    Deprecated imu_filter_controller
  * Merge branch 'master' into gimbal_track
  * Rename a msg.
  * Modifier track subscribe topic
  * Contributors: QiayuanLiao, YuuinIH, chenzheng, mlione, qiayuan, yezi

 -- Qiayuan Liao <liaoqiayuan@gmail.com>  Fri, 10 Jun 2022 00:00:00 -0000

ros-noetic-rm-gimbal-controllers (0.1.3-1focal) focal; urgency=high

  * Merge pull request #42 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/42> from ye-luo-xi-tui/fix_gimbal
    Fix bug in gimbal_controller
  * Merge pull request #37 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/37> from ye-luo-xi-tui/forward_feed
    Add feedforward in gimbal control
  * Merge branch 'master' into forward_feed
  * Simplify the codes. Set vel_target under rate mode.
  * Fix bug which relative to limit in gimbal_controller.
  * Merge pull request #40 <https://github.com/ye-luo-xi-tui/rm_controllers/issues/40> from ye-luo-xi-tui/maintain


=== debian/control ===
Source: ros-noetic-rm-gimbal-controllers
Section: misc
Priority: optional
Maintainer: Qiayuan Liao <liaoqiayuan@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-angles, ros-noetic-catkin, ros-noetic-controller-interface, ros-noetic-dynamic-reconfigure, ros-noetic-effort-controllers, ros-noetic-rm-common, ros-noetic-roscpp, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-rm-gimbal-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-angles, ros-noetic-controller-interface, ros-noetic-dynamic-reconfigure, ros-noetic-effort-controllers, ros-noetic-rm-common, ros-noetic-roscpp, ros-noetic-tf2-eigen, ros-noetic-tf2-geometry-msgs, ros-noetic-visualization-msgs
Description: RoboMaster standard robot Gimbal controller

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-rm-gimbal-controllers//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
